<?php

namespace FiloBlu\Kpi\Cron;

use FiloBlu\Kpi\Model\CreateviewsFactory;
use Psr\Log\LoggerInterface;

/**
 * Class Createviews
 * @package FiloBlu\Kpi\Cron
 */
class Createviews
{
    /**
     * @var LoggerInterface
     */
    protected $logger;

    /**
     * @var CreateviewsFactory
     */
    protected $kpiCreateViewsFactory;

    /**
     * Createviews constructor.
     * @param LoggerInterface $logger
     * @param CreateviewsFactory $kpiCreateViewsFactory
     */
    public function __construct(
        LoggerInterface $logger,
        CreateviewsFactory $kpiCreateViewsFactory
    ) {
        $this->logger = $logger;
        $this->kpiCreateViewsFactory = $kpiCreateViewsFactory;
    }

    /**
     *
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function execute()
    {
        $this->kpiCreateViewsFactory->create()->createViews();
    }
}
