<?php

namespace FiloBlu\Kpi\Helper;

use Magento\Framework\App\Helper\AbstractHelper;

use function strlen;

/**
 * Class Data
 * @package FiloBlu\Kpi\Helper
 */
class Data extends AbstractHelper
{
    /**
     * @var array
     */
    protected $loggers = [];

    /**
     * @return \Psr\Log\LoggerInterface
     */
    public function getLogger()
    {
        return $this->_logger;
    }

    /**
     * @return mixed
     */
    public function shouldForceKpiImagesHttps()
    {
        return $this->scopeConfig->getValue('kpi/general/forcehttps');
    }

    /**
     * @param $haystack
     * @param $needle
     * @param $replace
     * @return string|string[]
     */
    public function strReplaceFirst($haystack, $needle, $replace)
    {
        $pos = strpos($haystack, $needle);
        if ($pos !== false) {
            return substr_replace($haystack, $replace, $pos, strlen($needle));
        }
        return $haystack;
    }

}
