<?php

namespace FiloBlu\Kpi\Model;

use Exception;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\UrlInterface;

/**
 * Class Addkpidata
 * @package FiloBlu\Kpi\Model
 */
class Addkpidata extends Core
{
    /**
     *
     */
    public function addData()
    {
        $logger = $this->helper->getLogger();
        $productCollection = $this->getProductsCollection();

        $productCollection->AddAttributeToSelect('parent_sku_kpi', 'left');
        $productCollection->AddAttributeToSelect('url_image_kpi', 'left');
        $productCollection->addAttributeToFilter('type_id', 'simple');

        $tot = $productCollection->getSize();
        $i = 0;

        foreach ($productCollection as $simple) {
            $i++;

            try {
                $parentIds = $this->productConfigurable->getParentIdsByChild($simple->getId());

                if ($parentIds && is_array($parentIds) && count($parentIds) > 0) {
                    $parentId = $parentIds[0];
                } else {
                    $parentId = $simple->getId();
                }

                $parentProduct = $this->productRepository->getById($parentId);
                $parentSku = $parentProduct->getSku();

                $logger->info("Product $i of $tot");
                $logger->info("Product ID: {$simple->getId()}");
                $logger->info("Product SKU: $parentSku");

                if ($simple->getParentSkuKpi() !== $parentSku) {
                    $this->productAction->updateAttributes([$simple->getId()], ['parent_sku_kpi' => $parentSku], 0);
                }

                $absolutePath = $this->filesystem->getDirectoryRead(DirectoryList::MEDIA)->getAbsolutePath();
                $absolutePath .= 'catalog/product' . $parentProduct->getImage();

                $absolutePathImageResized = strtolower(
                    str_replace('catalog/product', 'catalog/product/bi', $absolutePath)
                );

                if (file_exists($absolutePath) && $parentProduct->getImage() && $parentProduct->getImage() != '') {
                    if (!file_exists($absolutePathImageResized)) {
                        $imageResize = $this->adapterFactory->create();
                        $imageResize->open($absolutePath);
                        $imageResize->constrainOnly(true);
                        $imageResize->keepAspectRatio(true);
                        $imageResize->resize(200, 200);
                        $imageResize->save($absolutePathImageResized);
                    }
                    $resizedUrl = $this->storeManager->getStore($this->getDefaultStoreIds(true))
                            ->getBaseUrl(UrlInterface::URL_TYPE_MEDIA) . 'catalog/product/bi' . strtolower(
                            $parentProduct->getImage()
                        );

                    if ($this->helper->shouldForceKpiImagesHttps()) {
                        $resizedUrl = $this->helper->strReplaceFirst($resizedUrl, 'http://', 'https://');
                    }
                } else {
                    $resizedUrl = null;
                }

                $logger->info("Image URL '$resizedUrl'");

                if ($simple->getUrlImageKpi() != $resizedUrl) {
                    $this->productAction->updateAttributes(
                        [$simple->getId()],
                        ['url_image_kpi' => $resizedUrl],
                        0
                    );
                }
            } catch (Exception $e) {
                $logger->error($e->getMessage(), ['exception' => $e]);
            }
        }
    }

}
